# Fortune Teller MicroServices - Fortune UI

## Overview
This repository is a microservice of the larger [Fortune Teller Application](https://github.com/msathe-tech/fortune-teller) guided as a workshop. This is a JavaScript UI layer using Spring MVC to git the [Fortune API](https://github.com/bernardpark/fortune-teller-service) "backend for frontend".

## Service Registry
By including spring-cloud-services-starter-service-registry, your application will now be registered in your Service Registry service instance in Pivotal Cloud Foundry.

Take a look at src/main/resources/bootstrap.yml as well. This properties file, to be read before your application.yml file, define s the name of this application when it is registered in your Service Registry. In the future, you may build out your microservices to reference each service by its registered name.

## Spring Cloud Config
Examine the `FortuneProperties.java` class. You should notice the `@ConfigurationProperties` annotation. This tells Spring that this class will act as a properties object consuming your remote configuration. The annotation includes `prefix = "api"` that identifies the configuration prefix. The `@RefreshScope` annotation, as included by the Spring Actuator dependency, will force recreation of this bean when the actuator/refresh endpoint is called. This will pull in the latest configuration from your config server when changes are made. 
Be sure to note the `apiURL` variable. Notice that it refers to the spring application naming convention, not an http/https url, we specify in our bootstrap.yml files, which is used to register application names in Service Registry.
In this series of applications, the Config Server should consume a git repository backend with a simple `application.yml` file. Re
fer to the [Fortune Config](https://github.com/bernardpark/fortune-teller-config) repository to see an example. You can notice in `deploy.sh` that a Config Server service is initialized with this particular configuration repository.

## Spring Cloud Registry
Now take a look at `FortuneService.java`. The `randomFortune()` method, which is invoked in the method mapped to `/random` endpoint in `FortuneController.java`, makes a rest call to the `apiURL` endpoint we saw earlier. By doing so, this application is referring to the binded Service Registry to call the service application.

## Spring Cloud Circuit Breaker
In the same `FortuneService.java` class, notice that the `randomFortune()` method is annotated with `@HystrixCommand( fallbackMethod = "fallbackFortune" )`. When this method fails, it falls back to the `fallbackFortune()` method below, to return a default response instead of an error code. This practice not only produces a non-critical error handler, but also helps implement a fail-fast methodology.

### Build and Deploy

Build and deploy application on current 'cf target'

```
./deploy.sh
```
When prompted for the App Suffix, give a unique identifier.

1. Push your applications

Examine the manifest.yml file to review the application deployment configurations and service bindings.

## Test the application

### Test the API endpoint
1. Make sure the [Fortune Service](https://github.com/bernardpark/fortune-teller-service) is deployed in the same environment.
1. Make sure the [Fortune API](https://github.com/bernardpark/fortune-teller-api) is deployed in the same environment.
1. Visit `https://$YOUR_UI_ENDPOINT`
1. Notice the random fortune returned
1. Refresh the page
1. Notice another random fortune returned

### Test the API Circuit Breaker
1. Stop your [Fortune Service](https://github.com/bernardpark/fortune-teller-service) (ex. `cf stop $YOUR_APP_SUFFIX-fortune-service`)
1. Visit `https://$YOUR_UI_ENDPOINT/random`
1. Notice the default fallback message generated by the API when it fails to call the Fortune Service

### Test the UI Circuit Breaker
1. Stop your [Fortune API](https://github.com/bernardpark/fortune-teller-api) (ex. `cf stop $YOUR_APP_SUFFIX-fortune-api`)
1. Visit `https://$YOUR_UI_ENDPOINT/random`
1. Notice the default fallback message generated by the UI when it fails to call the Fortune API

### Test Cloud Config
1. Make a change to you `application.yml` with a new fallback message
1. Refresh your application beans using the actuator endpoint (ex. `curl -k https://$YOUR_UI_ENDPOINT/actuator/refresh -X POST`)
1. Visit `https://$YOUR_UI_ENDPOINT/random`
1. Notice the changed default fallback message generated by the UI when it fails to call the Fortune API

## Clean up

You can choose to clean up your environment, or keep it for the next lab.

```
./scripts/undeploy.sh
```

## Return to Workshop Respository
[Fortune Teller Workshop](https://github.com/msathe-tech/fortune-teller)

## Authors
* **Bernard Park** - [Github](https://github.com/bernardpark)
